// This may look like C code, but it is really -*- C++ -*-
/****************************************************************************
** $Id: fancybaselog.h 818 2010-09-08 20:43:13Z fancylibs $
**
** Copyright (C) 2003 EV-i Informationstechnologie GmbH
**
** Author: Wolfgang Glas / EV-i
**
** Global logging stuff.
**
*****************************************************************************/

#ifndef FANCYBASE_LOG_H
#define FANCYBASE_LOG_H

#include <fancylog.h>
#include <fancybase.h>

// facility masks:
// facility "fancystdc++"
#define  FANCYBASE_LOG_STDCXX     (1<<0)
// facility "fancylibc"
#define  FANCYBASE_LOG_LIBC       (1<<1)
// facility "fancythread"
#define  FANCYBASE_LOG_THREAD     (1<<2)
// facility "fancycache"
#define  FANCYBASE_LOG_CACHE      (1<<3)
// facility "fancyapp"
#define  FANCYBASE_LOG_APP        (1<<4)
// facility "fancyserializer"
#define  FANCYBASE_LOG_SERIALIZER (1<<5)
// facility "fancyio"
#define  FANCYBASE_LOG_IO         (1<<6)
// facility "fancytimer"
#define  FANCYBASE_LOG_TIMER      (1<<7)
// facility "fancypool"
#define  FANCYBASE_LOG_POOL       (1<<8)

namespace Fancy {
  extern FANCYBASE_API fancylog_service *log_service;

  // parse for logging cmdline args and filter out recognized options.
  void FANCYBASE_API fancylog_parse_arg (int *argc, char **argv);

  inline void vfancylog (int facility,
                         int priority, const char *fmt, va_list ap)
  {
    va_list aq;
    va_copy(aq,ap);
    ::vfancylog(log_service,facility,priority,fmt,aq);
    va_end(aq);
  }

#ifdef __GNUG__
  inline void fancylog (int facility,
                        int priority, const char *fmt, ...)
    __attribute__((format(printf,3,4)));

#endif

  inline void fancylog (int facility,
                        int priority, const char *fmt, ...)
  {
    va_list ap;
    va_start(ap, fmt);
    vfancylog(facility,priority,fmt,ap);
    va_end(ap);
  }
}

#endif // ! FANCYBASE_LOG_H
