/*
 * fancyiterator.h
 *
 *  Created on: 19.05.2009
 *      Author: wglas
 */

#ifndef FANCYITERATOR_H_
#define FANCYITERATOR_H_

#include <fancyobject.h>

namespace Fancy {

/**
 * An iterator on an untyped Object container like @List or @Set
 */
class FANCYBASE_API Iterator: public virtual Fancy::Object {
public:
    typedef ObjPtr<Iterator> ptr_t;

    Iterator() {}

    virtual bool isBegin() const = 0;
    virtual bool isEnd()   const = 0;

    virtual ObjPtr<Object> getKey() const = 0;

    virtual ObjPtr<Object> getValue() const = 0;
    virtual void setValue(const ObjPtr<Object> &o) = 0;

    /**
     * Erase the current object and locate the iterator on the next element.
     */
    virtual void erase() = 0;

    virtual void next() = 0;
    virtual void previous() = 0;

protected:
    virtual ~Iterator();
};

}

#endif /* FANCYITERATOR_H_ */
