/*
 * fancythrowableexception.h
 *
 *  Created on: 22.07.2009
 *      Author: wglas
 */

#ifndef FANCYTHROWABLEEXCEPTION_H_
#define FANCYTHROWABLEEXCEPTION_H_

#include <fancyexception.h>
#include <fancyobject.h>

namespace Fancy {

class Throwable;

/**
 * This class acts as a bridge between Java Throwable instances and
 * C++ exceptions.
 */
class FANCYBASE_API ThrowableException: public Fancy::Exception {
public:
    ThrowableException(int facility,
                       int priority,
                       const ObjPtr<Throwable> &throwable) throw();

    virtual ~ThrowableException() throw();

    ObjPtr<Throwable> getThrowable() const;

    ThrowableException (fancylog_service *service,
                        int facility,
                        int priority,
                        const ObjPtr<Throwable> &throwable) throw();

private:

    void initMessage();
    ObjPtr<Throwable> throwable;
};

}

#endif /* FANCYTHROWABLEEXCEPTION_H_ */
